diff --git a/contrib/ntp/ntpd/ntp_parser.c b/contrib/ntp/ntpd/ntp_parser.c
index 834b1fbd1acc..e5ee5e10a459 100644
--- a/contrib/ntp/ntpd/ntp_parser.c
+++ b/contrib/ntp/ntpd/ntp_parser.c
@@ -1113,12 +1119,18 @@ typedef int yy_state_fast_t;
 # define YY_USE(E) /* empty */
 #endif
 
-#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
 /* Suppress an incorrect diagnostic about yylval being uninitialized.  */
-# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
+#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
+# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
+#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
+    _Pragma ("GCC diagnostic push")                                     \
+    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
+# else
+#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
     _Pragma ("GCC diagnostic push")                                     \
     _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
     _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
+# endif
 # define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
     _Pragma ("GCC diagnostic pop")
 #else
@@ -1275,21 +1287,21 @@ union yyalloc
 #endif /* !YYCOPY_NEEDED */
 
 /* YYFINAL -- State number of the termination state.  */
-#define YYFINAL  222
+#define YYFINAL  225
 /* YYLAST -- Last index in YYTABLE.  */
-#define YYLAST   688
+#define YYLAST   717
 
 /* YYNTOKENS -- Number of terminals.  */
-#define YYNTOKENS  221
+#define YYNTOKENS  222
 /* YYNNTS -- Number of nonterminals.  */
-#define YYNNTS  115
+#define YYNNTS  116
 /* YYNRULES -- Number of rules.  */
-#define YYNRULES  343
+#define YYNRULES  346
 /* YYNSTATES -- Number of states.  */
-#define YYNSTATES  463
+#define YYNSTATES  467
 
 /* YYMAXUTOK -- Last valid token kind.  */
-#define YYMAXUTOK   469
+#define YYMAXUTOK   470
 
 
 /* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
@@ -1307,15 +1319,15 @@ static const yytype_uint8 yytranslate[] =
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-     217,   218,     2,     2,     2,     2,     2,     2,     2,     2,
+     218,   219,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,   216,     2,     2,     2,     2,     2,     2,     2,     2,
+       2,   217,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
-       2,     2,     2,   219,   215,   220,     2,     2,     2,     2,
+       2,     2,     2,   220,   216,   221,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
        2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
@@ -1349,48 +1361,49 @@ static const yytype_uint8 yytranslate[] =
      175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
      185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
      195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
-     205,   206,   207,   208,   209,   210,   211,   212,   213,   214
+     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
+     215
 };
 
 #if YYDEBUG
-  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
+/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
 static const yytype_int16 yyrline[] =
 {
-       0,   397,   397,   401,   402,   403,   418,   419,   420,   421,
-     422,   423,   424,   425,   426,   427,   428,   429,   430,   431,
-     432,   440,   450,   451,   452,   453,   454,   458,   459,   464,
-     469,   471,   477,   478,   486,   487,   488,   492,   497,   498,
-     499,   500,   501,   502,   503,   504,   505,   509,   511,   516,
-     517,   518,   519,   520,   521,   525,   530,   539,   549,   550,
-     560,   562,   564,   566,   577,   584,   586,   591,   593,   595,
-     597,   599,   609,   615,   616,   624,   626,   638,   639,   640,
-     641,   642,   651,   656,   661,   669,   671,   673,   675,   680,
-     681,   682,   683,   684,   685,   686,   687,   688,   692,   693,
-     702,   704,   713,   723,   728,   736,   737,   738,   739,   740,
-     741,   742,   743,   748,   749,   757,   767,   776,   791,   796,
-     797,   801,   802,   806,   807,   808,   809,   810,   811,   812,
-     821,   825,   829,   837,   845,   853,   868,   883,   896,   897,
-     917,   918,   926,   937,   938,   939,   940,   941,   942,   943,
-     944,   945,   946,   947,   948,   949,   950,   951,   952,   953,
-     957,   962,   970,   975,   976,   977,   981,   986,   994,   999,
-    1000,  1001,  1002,  1003,  1004,  1005,  1006,  1014,  1024,  1029,
-    1037,  1039,  1041,  1050,  1052,  1057,  1058,  1059,  1063,  1064,
-    1065,  1066,  1074,  1084,  1089,  1097,  1102,  1103,  1111,  1116,
-    1121,  1129,  1134,  1135,  1136,  1145,  1147,  1152,  1157,  1165,
-    1167,  1184,  1185,  1186,  1187,  1188,  1189,  1193,  1194,  1195,
-    1196,  1197,  1198,  1206,  1211,  1216,  1224,  1229,  1230,  1231,
-    1232,  1233,  1234,  1235,  1236,  1237,  1238,  1247,  1248,  1249,
-    1256,  1263,  1270,  1286,  1305,  1313,  1315,  1317,  1319,  1321,
-    1323,  1325,  1332,  1337,  1338,  1339,  1343,  1347,  1356,  1358,
-    1361,  1365,  1369,  1370,  1371,  1375,  1386,  1404,  1417,  1418,
-    1423,  1449,  1450,  1455,  1460,  1462,  1467,  1468,  1476,  1478,
-    1486,  1491,  1499,  1524,  1531,  1541,  1542,  1546,  1547,  1548,
-    1549,  1553,  1554,  1555,  1559,  1564,  1569,  1577,  1578,  1579,
-    1580,  1581,  1582,  1583,  1593,  1598,  1606,  1611,  1619,  1621,
-    1625,  1630,  1635,  1643,  1648,  1656,  1665,  1666,  1670,  1671,
-    1675,  1683,  1701,  1705,  1710,  1718,  1723,  1724,  1728,  1733,
-    1741,  1746,  1751,  1756,  1761,  1769,  1774,  1779,  1787,  1792,
-    1793,  1794,  1795,  1796
+       0,   399,   399,   403,   404,   405,   420,   421,   422,   423,
+     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
+     434,   442,   452,   453,   454,   455,   456,   460,   461,   466,
+     471,   473,   479,   480,   488,   489,   490,   494,   499,   500,
+     501,   502,   503,   504,   505,   506,   507,   511,   513,   518,
+     519,   520,   521,   522,   523,   527,   532,   541,   551,   552,
+     562,   564,   566,   568,   579,   586,   588,   593,   595,   597,
+     599,   601,   611,   617,   618,   626,   628,   640,   641,   642,
+     643,   644,   653,   658,   663,   671,   673,   675,   677,   682,
+     683,   684,   685,   686,   687,   688,   689,   690,   694,   695,
+     704,   706,   715,   725,   730,   738,   739,   740,   741,   742,
+     743,   744,   745,   750,   751,   759,   769,   778,   793,   798,
+     799,   803,   804,   808,   809,   810,   811,   812,   813,   814,
+     823,   827,   831,   840,   849,   865,   881,   891,   900,   916,
+     917,   925,   926,   946,   947,   955,   966,   967,   968,   969,
+     970,   971,   972,   973,   974,   975,   976,   977,   978,   979,
+     980,   981,   982,   986,   991,   999,  1004,  1005,  1006,  1010,
+    1015,  1023,  1028,  1029,  1030,  1031,  1032,  1033,  1034,  1035,
+    1043,  1053,  1058,  1066,  1068,  1070,  1079,  1081,  1086,  1087,
+    1088,  1092,  1093,  1094,  1095,  1103,  1113,  1118,  1126,  1131,
+    1132,  1140,  1145,  1150,  1158,  1163,  1164,  1165,  1174,  1176,
+    1181,  1186,  1194,  1196,  1213,  1214,  1215,  1216,  1217,  1218,
+    1222,  1223,  1224,  1225,  1226,  1227,  1235,  1240,  1245,  1253,
+    1258,  1259,  1260,  1261,  1262,  1263,  1264,  1265,  1266,  1267,
+    1276,  1277,  1278,  1285,  1292,  1299,  1315,  1334,  1342,  1344,
+    1346,  1348,  1350,  1352,  1354,  1361,  1366,  1367,  1368,  1372,
+    1376,  1385,  1387,  1390,  1394,  1398,  1399,  1400,  1404,  1415,
+    1433,  1446,  1447,  1452,  1478,  1484,  1489,  1494,  1496,  1501,
+    1502,  1510,  1512,  1520,  1525,  1533,  1558,  1565,  1575,  1576,
+    1580,  1581,  1582,  1583,  1587,  1588,  1589,  1593,  1598,  1603,
+    1611,  1612,  1613,  1614,  1615,  1616,  1617,  1627,  1632,  1640,
+    1645,  1653,  1655,  1659,  1664,  1669,  1677,  1682,  1690,  1699,
+    1700,  1704,  1705,  1709,  1717,  1735,  1739,  1744,  1752,  1757,
+    1758,  1762,  1767,  1775,  1780,  1785,  1790,  1795,  1803,  1808,
+    1813,  1821,  1826,  1827,  1828,  1829,  1830
 };
 #endif
 
@@ -1412,11 +1425,11 @@ static const char *const yytname[] =
   "T_Broadcast", "T_Broadcastclient", "T_Broadcastdelay", "T_Burst",
   "T_Calibrate", "T_Ceiling", "T_Checkhash", "T_Clockstats", "T_Cohort",
   "T_ControlKey", "T_Crypto", "T_Cryptostats", "T_Ctl", "T_Day",
-  "T_Default", "T_Device", "T_Digest", "T_Disable", "T_Discard",
-  "T_Dispersion", "T_Double", "T_Driftfile", "T_Drop", "T_Dscp",
-  "T_Ellipsis", "T_Enable", "T_End", "T_Epeer", "T_False", "T_File",
-  "T_Filegen", "T_Filenum", "T_Flag1", "T_Flag2", "T_Flag3", "T_Flag4",
-  "T_Flake", "T_Floor", "T_Freq", "T_Fudge", "T_Fuzz", "T_Host",
+  "T_Default", "T_Delrestrict", "T_Device", "T_Digest", "T_Disable",
+  "T_Discard", "T_Dispersion", "T_Double", "T_Driftfile", "T_Drop",
+  "T_Dscp", "T_Ellipsis", "T_Enable", "T_End", "T_Epeer", "T_False",
+  "T_File", "T_Filegen", "T_Filenum", "T_Flag1", "T_Flag2", "T_Flag3",
+  "T_Flag4", "T_Flake", "T_Floor", "T_Freq", "T_Fudge", "T_Fuzz", "T_Host",
   "T_Huffpuff", "T_Iburst", "T_Ident", "T_Ignore", "T_Ignorehash",
   "T_Incalloc", "T_Incmem", "T_Initalloc", "T_Initmem", "T_Includefile",
   "T_Integer", "T_Interface", "T_Intrange", "T_Io", "T_Ippeerlimit",
@@ -1458,10 +1471,10 @@ static const char *const yytname[] =
   "tos_option", "tos_option_int_keyword", "tos_option_dbl_keyword",
   "monitoring_command", "stats_list", "stat", "filegen_option_list",
   "filegen_option", "link_nolink", "enable_disable", "filegen_type",
-  "access_control_command", "res_ippeerlimit", "ac_flag_list",
-  "access_control_flag", "discard_option_list", "discard_option",
-  "discard_option_keyword", "mru_option_list", "mru_option",
-  "mru_option_keyword", "fudge_command", "fudge_factor_list",
+  "access_control_command", "restrict_mask", "res_ippeerlimit",
+  "ac_flag_list", "access_control_flag", "discard_option_list",
+  "discard_option", "discard_option_keyword", "mru_option_list",
+  "mru_option", "mru_option_keyword", "fudge_command", "fudge_factor_list",
   "fudge_factor", "fudge_factor_dbl_keyword", "fudge_factor_bool_keyword",
   "device_command", "device_item_list", "device_item",
   "device_item_path_keyword", "rlimit_command", "rlimit_option_list",
@@ -1492,38 +1505,7 @@ yysymbol_name (yysymbol_kind_t yysymbol)
 }
 #endif
 
-#ifdef YYPRINT
-/* YYTOKNUM[NUM] -- (External) token number corresponding to the
-   (internal) symbol number NUM (which must be that of a token).  */
-static const yytype_int16 yytoknum[] =
-{
-       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
-     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
-     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
-     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
-     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
-     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
-     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
-     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
-     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
-     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
-     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
-     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
-     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
-     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
-     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
-     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
-     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
-     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
-     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
-     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
-     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
-     465,   466,   467,   468,   469,   124,    61,    40,    41,   123,
-     125
-};
-#endif
-
-#define YYPACT_NINF (-247)
+#define YYPACT_NINF (-280)
 
 #define yypact_value_is_default(Yyn) \
   ((Yyn) == YYPACT_NINF)
